diff --git a/gdb/cli/cli-interp.c b/gdb/cli/cli-interp.c
index 00310542a8db..ffb40729fc61 100644
--- a/gdb/cli/cli-interp.c
+++ b/gdb/cli/cli-interp.c
@@ -158,15 +158,9 @@ cli_interp_base::on_sync_execution_done ()
   display_gdb_prompt (NULL);
 }
 
-/* Observer for the command_error notification.  */
-
-static void
-cli_base_on_command_error ()
+void
+cli_interp_base::on_command_error ()
 {
-  cli_interp_base *cli = as_cli_interp_base (top_level_interpreter ());
-  if (cli == nullptr)
-    return;
-
   display_gdb_prompt (NULL);
 }
 
@@ -355,8 +349,6 @@ _initialize_cli_interp ()
   interp_factory_register (INTERP_CONSOLE, cli_interp_factory);
 
   /* Note these all work for both the CLI and TUI interpreters.  */
-  gdb::observers::command_error.attach (cli_base_on_command_error,
-					"cli-interp-base");
   gdb::observers::user_selected_context_changed.attach
     (cli_base_on_user_selected_context_changed, "cli-interp-base");
 }
diff --git a/gdb/cli/cli-interp.h b/gdb/cli/cli-interp.h
index 4680c8070fd0..5020b2bc6ef4 100644
--- a/gdb/cli/cli-interp.h
+++ b/gdb/cli/cli-interp.h
@@ -39,6 +39,7 @@ class cli_interp_base : public interp
   void on_exited (int status) override;
   void on_no_history () override;
   void on_sync_execution_done () override;
+  void on_command_error () override;
 
 private:
   struct saved_output_files
diff --git a/gdb/interps.h b/gdb/interps.h
index 349ffb1bdcf7..53d951b8d637 100644
--- a/gdb/interps.h
+++ b/gdb/interps.h
@@ -106,6 +106,10 @@ class interp : public intrusive_list_node<interp>
      finished.  */
   virtual void on_sync_execution_done () {}
 
+  /* Notify the interpreter that an error was caught while executing a
+     command on this interpreter.  */
+  virtual void on_command_error () {}
+
 private:
   /* The memory for this is static, it comes from literal strings (e.g. "cli").  */
   const char *m_name;
diff --git a/gdb/main.c b/gdb/main.c
index 5c23714f52e0..47eec0e50730 100644
--- a/gdb/main.c
+++ b/gdb/main.c
@@ -430,7 +430,7 @@ start_event_loop ()
 	     get around to resetting the prompt, which leaves readline
 	     in a messed-up state.  Reset it here.  */
 	  current_ui->prompt_state = PROMPT_NEEDED;
-	  gdb::observers::command_error.notify ();
+	  top_level_interpreter ()->on_command_error ();
 	  /* This call looks bizarre, but it is required.  If the user
 	     entered a command that caused an error,
 	     after_char_processing_hook won't be called from
diff --git a/gdb/mi/mi-interp.c b/gdb/mi/mi-interp.c
index 21c0fb6e73f7..45160571ce98 100644
--- a/gdb/mi/mi-interp.c
+++ b/gdb/mi/mi-interp.c
@@ -104,14 +104,10 @@ as_mi_interp (struct interp *interp)
   return dynamic_cast<mi_interp *> (interp);
 }
 
-/* Observer for the command_error notification.  */
-
-static void
-mi_on_command_error ()
+void
+mi_interp::on_command_error ()
 {
-  mi_interp *mi = as_mi_interp (top_level_interpreter ());
-  if (mi != nullptr)
-    display_mi_prompt (mi);
+  display_mi_prompt (this);
 }
 
 void
@@ -1236,7 +1232,6 @@ _initialize_mi_interp ()
 					      "mi-interp");
   gdb::observers::command_param_changed.attach (mi_command_param_changed,
 						"mi-interp");
-  gdb::observers::command_error.attach (mi_on_command_error, "mi-interp");
   gdb::observers::memory_changed.attach (mi_memory_changed, "mi-interp");
   gdb::observers::user_selected_context_changed.attach
     (mi_user_selected_context_changed, "mi-interp");
diff --git a/gdb/mi/mi-interp.h b/gdb/mi/mi-interp.h
index 15ba8dab15bd..08edaceb99cd 100644
--- a/gdb/mi/mi-interp.h
+++ b/gdb/mi/mi-interp.h
@@ -48,6 +48,7 @@ class mi_interp final : public interp
   void on_exited (int status) override;
   void on_no_history () override;
   void on_sync_execution_done () override;
+  void on_command_error () override;
 
   /* MI's output channels */
   mi_console_file *out;
diff --git a/gdb/observable.c b/gdb/observable.c
index f52989d7a638..bfb92b4fe15e 100644
--- a/gdb/observable.c
+++ b/gdb/observable.c
@@ -34,7 +34,6 @@ bool observer_debug = false;
 
 DEFINE_OBSERVABLE (normal_stop);
 DEFINE_OBSERVABLE (signal_received);
-DEFINE_OBSERVABLE (command_error);
 DEFINE_OBSERVABLE (target_changed);
 DEFINE_OBSERVABLE (executable_changed);
 DEFINE_OBSERVABLE (inferior_created);
diff --git a/gdb/observable.h b/gdb/observable.h
index 4be05efa0231..1ec927671e53 100644
--- a/gdb/observable.h
+++ b/gdb/observable.h
@@ -57,9 +57,6 @@ extern observable<struct bpstat */* bs */, int /* print_frame */> normal_stop;
 /* The inferior was stopped by a signal.  */
 extern observable<enum gdb_signal /* siggnal */> signal_received;
 
-/* An error was caught while executing a command.  */
-extern observable<> command_error;
-
 /* The target's register contents have changed.  */
 extern observable<struct target_ops */* target */> target_changed;
 