diff --git a/gdb/cli/cli-interp.c b/gdb/cli/cli-interp.c
index aba73f142af8..6cb315cb57d2 100644
--- a/gdb/cli/cli-interp.c
+++ b/gdb/cli/cli-interp.c
@@ -140,19 +140,10 @@ cli_interp_base::on_signal_exited (gdb_signal sig)
   print_signal_exited_reason (this->interp_ui_out (), sig);
 }
 
-/* Observer for the exited notification.  */
-
-static void
-cli_base_on_exited (int exitstatus)
+void
+cli_interp_base::on_exited (int status)
 {
-  SWITCH_THRU_ALL_UIS ()
-    {
-      cli_interp_base *cli = as_cli_interp_base (top_level_interpreter ());
-      if (cli == nullptr)
-	continue;
-
-      print_exited_reason (cli->interp_ui_out (), exitstatus);
-    }
+  print_exited_reason (this->interp_ui_out (), status);
 }
 
 /* Observer for the no_history notification.  */
@@ -379,7 +370,6 @@ _initialize_cli_interp ()
   interp_factory_register (INTERP_CONSOLE, cli_interp_factory);
 
   /* Note these all work for both the CLI and TUI interpreters.  */
-  gdb::observers::exited.attach (cli_base_on_exited, "cli-interp-base");
   gdb::observers::no_history.attach (cli_base_on_no_history, "cli-interp-base");
   gdb::observers::sync_execution_done.attach (cli_base_on_sync_execution_done,
 					      "cli-interp-base");
diff --git a/gdb/cli/cli-interp.h b/gdb/cli/cli-interp.h
index 6342efa2dd59..2e50860efa9e 100644
--- a/gdb/cli/cli-interp.h
+++ b/gdb/cli/cli-interp.h
@@ -36,6 +36,7 @@ class cli_interp_base : public interp
   void on_signal_received (gdb_signal sig) override;
   void on_signal_exited (gdb_signal sig) override;
   void on_normal_stop (bpstat *bs, int print_frame) override;
+  void on_exited (int status) override;
 
 private:
   struct saved_output_files
diff --git a/gdb/infrun.c b/gdb/infrun.c
index c458e559b1da..7320adb5b2ff 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -5727,7 +5727,7 @@ handle_inferior_event (struct execution_control_state *ecs)
 	  /* Support the --return-child-result option.  */
 	  return_child_result_value = ecs->ws.exit_status ();
 
-	  gdb::observers::exited.notify (ecs->ws.exit_status ());
+	  interps_notify_exited (ecs->ws.exit_status ());
 	}
       else
 	{
diff --git a/gdb/interps.c b/gdb/interps.c
index 566b5e1195ab..a7fede1d3312 100644
--- a/gdb/interps.c
+++ b/gdb/interps.c
@@ -422,6 +422,14 @@ interps_notify_normal_stop (bpstat *bs, int print_frame)
   interps_notify (&interp::on_normal_stop, bs, print_frame);
 }
 
+/* See interps.h.  */
+
+void
+interps_notify_exited (int status)
+{
+  interps_notify (&interp::on_exited, status);
+}
+
 /* This just adds the "interpreter-exec" command.  */
 void _initialize_interpreter ();
 void
diff --git a/gdb/interps.h b/gdb/interps.h
index 752f2e8ea61b..6c2656dd1b07 100644
--- a/gdb/interps.h
+++ b/gdb/interps.h
@@ -94,6 +94,10 @@ class interp : public intrusive_list_node<interp>
   /* Notify the interpreter that the current inferior has stopped normally.  */
   virtual void on_normal_stop (bpstat *bs, int print_frame) {}
 
+  /* Notify the intepreter that the current inferior has exited normally with
+     status STATUS.  */
+  virtual void on_exited (int status) {}
+
 private:
   /* The memory for this is static, it comes from literal strings (e.g. "cli").  */
   const char *m_name;
@@ -193,6 +197,10 @@ extern void interps_notify_signal_exited (gdb_signal sig);
 /* Notify all interpreters that the current inferior has stopped normally.  */
 extern void interps_notify_normal_stop (bpstat *bs, int print_frame);
 
+/* Notify all interpreters that the current inferior has exited normally with
+   status STATUS.  */
+extern void interps_notify_exited (int status);
+
 /* well-known interpreters */
 #define INTERP_CONSOLE		"console"
 #define INTERP_MI2             "mi2"
diff --git a/gdb/mi/mi-interp.c b/gdb/mi/mi-interp.c
index 2bf9e69393d4..56c59f3ac462 100644
--- a/gdb/mi/mi-interp.c
+++ b/gdb/mi/mi-interp.c
@@ -60,7 +60,6 @@ static int mi_interp_query_hook (const char *ctlstr, va_list ap)
 static void mi_insert_notify_hooks (void);
 static void mi_remove_notify_hooks (void);
 
-static void mi_on_exited (int exitstatus);
 static void mi_on_no_history (void);
 
 static void mi_new_thread (struct thread_info *t);
@@ -535,21 +534,11 @@ mi_interp::on_signal_exited (gdb_signal sig)
   print_signal_exited_reason (this->cli_uiout, sig);
 }
 
-/* Observer for the exited notification.  */
-
-static void
-mi_on_exited (int exitstatus)
+void
+mi_interp::on_exited (int status)
 {
-  SWITCH_THRU_ALL_UIS ()
-    {
-      struct mi_interp *mi = find_mi_interp ();
-
-      if (mi == NULL)
-	continue;
-
-      print_exited_reason (mi->mi_uiout, exitstatus);
-      print_exited_reason (mi->cli_uiout, exitstatus);
-    }
+  print_exited_reason (this->mi_uiout, status);
+  print_exited_reason (this->cli_uiout, status);
 }
 
 /* Observer for the no_history notification.  */
@@ -1263,7 +1252,6 @@ _initialize_mi_interp ()
   interp_factory_register (INTERP_MI4, mi_interp_factory);
   interp_factory_register (INTERP_MI, mi_interp_factory);
 
-  gdb::observers::exited.attach (mi_on_exited, "mi-interp");
   gdb::observers::no_history.attach (mi_on_no_history, "mi-interp");
   gdb::observers::new_thread.attach (mi_new_thread, "mi-interp");
   gdb::observers::thread_exit.attach (mi_thread_exit, "mi-interp");
diff --git a/gdb/mi/mi-interp.h b/gdb/mi/mi-interp.h
index 31e683319f89..1c828b5c508f 100644
--- a/gdb/mi/mi-interp.h
+++ b/gdb/mi/mi-interp.h
@@ -45,6 +45,7 @@ class mi_interp final : public interp
   void on_signal_received (gdb_signal sig) override;
   void on_signal_exited (gdb_signal sig) override;
   void on_normal_stop (struct bpstat *bs, int print_frame) override;
+  void on_exited (int status) override;
 
   /* MI's output channels */
   mi_console_file *out;
diff --git a/gdb/observable.c b/gdb/observable.c
index 8cbf0377b0bc..843890023834 100644
--- a/gdb/observable.c
+++ b/gdb/observable.c
@@ -34,7 +34,6 @@ bool observer_debug = false;
 
 DEFINE_OBSERVABLE (normal_stop);
 DEFINE_OBSERVABLE (signal_received);
-DEFINE_OBSERVABLE (exited);
 DEFINE_OBSERVABLE (no_history);
 DEFINE_OBSERVABLE (sync_execution_done);
 DEFINE_OBSERVABLE (command_error);
diff --git a/gdb/observable.h b/gdb/observable.h
index aaf1ddda4d42..25af2da6e935 100644
--- a/gdb/observable.h
+++ b/gdb/observable.h
@@ -57,9 +57,6 @@ extern observable<struct bpstat */* bs */, int /* print_frame */> normal_stop;
 /* The inferior was stopped by a signal.  */
 extern observable<enum gdb_signal /* siggnal */> signal_received;
 
-/* The inferior program is finished.  */
-extern observable<int /* exitstatus */> exited;
-
 /* Reverse execution: target ran out of history info.  */
 extern observable<> no_history;
 