diff --git a/gdb/cli/cli-interp.c b/gdb/cli/cli-interp.c
index 98bc2033f2c6..00310542a8db 100644
--- a/gdb/cli/cli-interp.c
+++ b/gdb/cli/cli-interp.c
@@ -152,15 +152,9 @@ cli_interp_base::on_no_history ()
   print_no_history_reason (this->interp_ui_out ());
 }
 
-/* Observer for the sync_execution_done notification.  */
-
-static void
-cli_base_on_sync_execution_done ()
+void
+cli_interp_base::on_sync_execution_done ()
 {
-  cli_interp_base *cli = as_cli_interp_base (top_level_interpreter ());
-  if (cli == nullptr)
-    return;
-
   display_gdb_prompt (NULL);
 }
 
@@ -361,8 +355,6 @@ _initialize_cli_interp ()
   interp_factory_register (INTERP_CONSOLE, cli_interp_factory);
 
   /* Note these all work for both the CLI and TUI interpreters.  */
-  gdb::observers::sync_execution_done.attach (cli_base_on_sync_execution_done,
-					      "cli-interp-base");
   gdb::observers::command_error.attach (cli_base_on_command_error,
 					"cli-interp-base");
   gdb::observers::user_selected_context_changed.attach
diff --git a/gdb/cli/cli-interp.h b/gdb/cli/cli-interp.h
index 7fc22a042d73..4680c8070fd0 100644
--- a/gdb/cli/cli-interp.h
+++ b/gdb/cli/cli-interp.h
@@ -38,6 +38,7 @@ class cli_interp_base : public interp
   void on_normal_stop (bpstat *bs, int print_frame) override;
   void on_exited (int status) override;
   void on_no_history () override;
+  void on_sync_execution_done () override;
 
 private:
   struct saved_output_files
diff --git a/gdb/infrun.c b/gdb/infrun.c
index f86ec7a2ed81..8d648cf04f0a 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -4206,7 +4206,7 @@ check_curr_ui_sync_execution_done (void)
       && !gdb_in_secondary_prompt_p (ui))
     {
       target_terminal::ours ();
-      gdb::observers::sync_execution_done.notify ();
+      top_level_interpreter ()->on_sync_execution_done ();
       ui->register_file_handler ();
     }
 }
diff --git a/gdb/interps.h b/gdb/interps.h
index 915a5f74eb73..349ffb1bdcf7 100644
--- a/gdb/interps.h
+++ b/gdb/interps.h
@@ -102,6 +102,10 @@ class interp : public intrusive_list_node<interp>
      execution because there is no more history.  */
   virtual void on_no_history () {}
 
+  /* Notify the interpreter that a synchronous command it started has
+     finished.  */
+  virtual void on_sync_execution_done () {}
+
 private:
   /* The memory for this is static, it comes from literal strings (e.g. "cli").  */
   const char *m_name;
diff --git a/gdb/mi/mi-interp.c b/gdb/mi/mi-interp.c
index a147c46ecf3b..21c0fb6e73f7 100644
--- a/gdb/mi/mi-interp.c
+++ b/gdb/mi/mi-interp.c
@@ -82,7 +82,6 @@ static void mi_breakpoint_modified (struct breakpoint *b);
 static void mi_command_param_changed (const char *param, const char *value);
 static void mi_memory_changed (struct inferior *inf, CORE_ADDR memaddr,
 			       ssize_t len, const bfd_byte *myaddr);
-static void mi_on_sync_execution_done (void);
 
 /* Display the MI prompt.  */
 
@@ -268,20 +267,13 @@ mi_execute_command_wrapper (const char *cmd)
   mi_execute_command (cmd, ui->instream == ui->stdin_stream);
 }
 
-/* Observer for the synchronous_command_done notification.  */
-
-static void
-mi_on_sync_execution_done (void)
+void
+mi_interp::on_sync_execution_done ()
 {
-  struct mi_interp *mi = as_mi_interp (top_level_interpreter ());
-
-  if (mi == NULL)
-    return;
-
   /* If MI is sync, then output the MI prompt now, indicating we're
      ready for further input.  */
   if (!mi_async_p ())
-    display_mi_prompt (mi);
+    display_mi_prompt (this);
 }
 
 /* mi_execute_command_wrapper wrapper suitable for INPUT_HANDLER.  */
@@ -1246,8 +1238,6 @@ _initialize_mi_interp ()
 						"mi-interp");
   gdb::observers::command_error.attach (mi_on_command_error, "mi-interp");
   gdb::observers::memory_changed.attach (mi_memory_changed, "mi-interp");
-  gdb::observers::sync_execution_done.attach (mi_on_sync_execution_done,
-					      "mi-interp");
   gdb::observers::user_selected_context_changed.attach
     (mi_user_selected_context_changed, "mi-interp");
 }
diff --git a/gdb/mi/mi-interp.h b/gdb/mi/mi-interp.h
index aeebc3207526..15ba8dab15bd 100644
--- a/gdb/mi/mi-interp.h
+++ b/gdb/mi/mi-interp.h
@@ -47,6 +47,7 @@ class mi_interp final : public interp
   void on_normal_stop (struct bpstat *bs, int print_frame) override;
   void on_exited (int status) override;
   void on_no_history () override;
+  void on_sync_execution_done () override;
 
   /* MI's output channels */
   mi_console_file *out;
diff --git a/gdb/observable.c b/gdb/observable.c
index 502e2d988cd1..f52989d7a638 100644
--- a/gdb/observable.c
+++ b/gdb/observable.c
@@ -34,7 +34,6 @@ bool observer_debug = false;
 
 DEFINE_OBSERVABLE (normal_stop);
 DEFINE_OBSERVABLE (signal_received);
-DEFINE_OBSERVABLE (sync_execution_done);
 DEFINE_OBSERVABLE (command_error);
 DEFINE_OBSERVABLE (target_changed);
 DEFINE_OBSERVABLE (executable_changed);
diff --git a/gdb/observable.h b/gdb/observable.h
index b06d13be0362..4be05efa0231 100644
--- a/gdb/observable.h
+++ b/gdb/observable.h
@@ -57,9 +57,6 @@ extern observable<struct bpstat */* bs */, int /* print_frame */> normal_stop;
 /* The inferior was stopped by a signal.  */
 extern observable<enum gdb_signal /* siggnal */> signal_received;
 
-/* A synchronous command finished.  */
-extern observable<> sync_execution_done;
-
 /* An error was caught while executing a command.  */
 extern observable<> command_error;
 