diff --git a/gdb/cli/cli-interp.c b/gdb/cli/cli-interp.c
index 9508171e87d5..aba73f142af8 100644
--- a/gdb/cli/cli-interp.c
+++ b/gdb/cli/cli-interp.c
@@ -134,19 +134,10 @@ cli_interp_base::on_signal_received (enum gdb_signal siggnal)
   print_signal_received_reason (this->interp_ui_out (), siggnal);
 }
 
-/* Observer for the signalled notification.  */
-
-static void
-cli_base_on_signal_exited (enum gdb_signal siggnal)
+void
+cli_interp_base::on_signal_exited (gdb_signal sig)
 {
-  SWITCH_THRU_ALL_UIS ()
-    {
-      cli_interp_base *cli = as_cli_interp_base (top_level_interpreter ());
-      if (cli == nullptr)
-	continue;
-
-      print_signal_exited_reason (cli->interp_ui_out (), siggnal);
-    }
+  print_signal_exited_reason (this->interp_ui_out (), sig);
 }
 
 /* Observer for the exited notification.  */
@@ -388,8 +379,6 @@ _initialize_cli_interp ()
   interp_factory_register (INTERP_CONSOLE, cli_interp_factory);
 
   /* Note these all work for both the CLI and TUI interpreters.  */
-  gdb::observers::signal_exited.attach (cli_base_on_signal_exited,
-					"cli-interp-base");
   gdb::observers::exited.attach (cli_base_on_exited, "cli-interp-base");
   gdb::observers::no_history.attach (cli_base_on_no_history, "cli-interp-base");
   gdb::observers::sync_execution_done.attach (cli_base_on_sync_execution_done,
diff --git a/gdb/cli/cli-interp.h b/gdb/cli/cli-interp.h
index 4fca801d4fd6..6342efa2dd59 100644
--- a/gdb/cli/cli-interp.h
+++ b/gdb/cli/cli-interp.h
@@ -34,7 +34,8 @@ class cli_interp_base : public interp
   bool supports_command_editing () override;
 
   void on_signal_received (gdb_signal sig) override;
-  void on_normal_stop(bpstat *bs, int print_frame) override;
+  void on_signal_exited (gdb_signal sig) override;
+  void on_normal_stop (bpstat *bs, int print_frame) override;
 
 private:
   struct saved_output_files
diff --git a/gdb/infrun.c b/gdb/infrun.c
index 8fa2cacc4149..c458e559b1da 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -5754,7 +5754,7 @@ handle_inferior_event (struct execution_control_state *ecs)
 				   "signal number.");
 	    }
 
-	  gdb::observers::signal_exited.notify (ecs->ws.sig ());
+	  interps_notify_signal_exited (ecs->ws.sig ());
 	}
 
       gdb_flush (gdb_stdout);
diff --git a/gdb/interps.c b/gdb/interps.c
index 80160bc45f34..566b5e1195ab 100644
--- a/gdb/interps.c
+++ b/gdb/interps.c
@@ -408,6 +408,14 @@ interps_notify_signal_received (gdb_signal sig)
 
 /* See interps.h.  */
 
+void
+interps_notify_signal_exited (gdb_signal sig)
+{
+  interps_notify (&interp::on_signal_exited, sig);
+}
+
+/* See interps.h.  */
+
 void
 interps_notify_normal_stop (bpstat *bs, int print_frame)
 {
diff --git a/gdb/interps.h b/gdb/interps.h
index dd5a9b70e339..752f2e8ea61b 100644
--- a/gdb/interps.h
+++ b/gdb/interps.h
@@ -87,6 +87,10 @@ class interp : public intrusive_list_node<interp>
      SIG.  */
   virtual void on_signal_received (gdb_signal sig) {}
 
+  /* Notify the interpreter that the current inferior has exited with signal
+     SIG. */
+  virtual void on_signal_exited (gdb_signal sig) {}
+
   /* Notify the interpreter that the current inferior has stopped normally.  */
   virtual void on_normal_stop (bpstat *bs, int print_frame) {}
 
@@ -182,6 +186,10 @@ extern void interpreter_completer (struct cmd_list_element *ignore,
    SIG.  */
 extern void interps_notify_signal_received (gdb_signal sig);
 
+/* Notify all interpreters that the current inferior has exited with signal
+   SIG.  */
+extern void interps_notify_signal_exited (gdb_signal sig);
+
 /* Notify all interpreters that the current inferior has stopped normally.  */
 extern void interps_notify_normal_stop (bpstat *bs, int print_frame);
 
diff --git a/gdb/mi/mi-interp.c b/gdb/mi/mi-interp.c
index 5aeba46c4c28..2bf9e69393d4 100644
--- a/gdb/mi/mi-interp.c
+++ b/gdb/mi/mi-interp.c
@@ -60,7 +60,6 @@ static int mi_interp_query_hook (const char *ctlstr, va_list ap)
 static void mi_insert_notify_hooks (void);
 static void mi_remove_notify_hooks (void);
 
-static void mi_on_signal_exited (enum gdb_signal siggnal);
 static void mi_on_exited (int exitstatus);
 static void mi_on_no_history (void);
 
@@ -529,21 +528,11 @@ mi_interp::on_signal_received (enum gdb_signal siggnal)
   print_signal_received_reason (this->cli_uiout, siggnal);
 }
 
-/* Observer for the signal_exited notification.  */
-
-static void
-mi_on_signal_exited (enum gdb_signal siggnal)
+void
+mi_interp::on_signal_exited (gdb_signal sig)
 {
-  SWITCH_THRU_ALL_UIS ()
-    {
-      struct mi_interp *mi = find_mi_interp ();
-
-      if (mi == NULL)
-	continue;
-
-      print_signal_exited_reason (mi->mi_uiout, siggnal);
-      print_signal_exited_reason (mi->cli_uiout, siggnal);
-    }
+  print_signal_exited_reason (this->mi_uiout, sig);
+  print_signal_exited_reason (this->cli_uiout, sig);
 }
 
 /* Observer for the exited notification.  */
@@ -1274,7 +1263,6 @@ _initialize_mi_interp ()
   interp_factory_register (INTERP_MI4, mi_interp_factory);
   interp_factory_register (INTERP_MI, mi_interp_factory);
 
-  gdb::observers::signal_exited.attach (mi_on_signal_exited, "mi-interp");
   gdb::observers::exited.attach (mi_on_exited, "mi-interp");
   gdb::observers::no_history.attach (mi_on_no_history, "mi-interp");
   gdb::observers::new_thread.attach (mi_new_thread, "mi-interp");
diff --git a/gdb/mi/mi-interp.h b/gdb/mi/mi-interp.h
index 444625f22c88..31e683319f89 100644
--- a/gdb/mi/mi-interp.h
+++ b/gdb/mi/mi-interp.h
@@ -43,6 +43,7 @@ class mi_interp final : public interp
   void pre_command_loop () override;
 
   void on_signal_received (gdb_signal sig) override;
+  void on_signal_exited (gdb_signal sig) override;
   void on_normal_stop (struct bpstat *bs, int print_frame) override;
 
   /* MI's output channels */
diff --git a/gdb/observable.c b/gdb/observable.c
index 82563e3fab47..8cbf0377b0bc 100644
--- a/gdb/observable.c
+++ b/gdb/observable.c
@@ -34,7 +34,6 @@ bool observer_debug = false;
 
 DEFINE_OBSERVABLE (normal_stop);
 DEFINE_OBSERVABLE (signal_received);
-DEFINE_OBSERVABLE (signal_exited);
 DEFINE_OBSERVABLE (exited);
 DEFINE_OBSERVABLE (no_history);
 DEFINE_OBSERVABLE (sync_execution_done);
diff --git a/gdb/observable.h b/gdb/observable.h
index e4e6f021f1a9..aaf1ddda4d42 100644
--- a/gdb/observable.h
+++ b/gdb/observable.h
@@ -57,9 +57,6 @@ extern observable<struct bpstat */* bs */, int /* print_frame */> normal_stop;
 /* The inferior was stopped by a signal.  */
 extern observable<enum gdb_signal /* siggnal */> signal_received;
 
-/* The inferior was terminated by a signal.  */
-extern observable<enum gdb_signal /* siggnal */> signal_exited;
-
 /* The inferior program is finished.  */
 extern observable<int /* exitstatus */> exited;
 